import invariant from"./internal/invariant.js";var matcher=/:([a-zA-Z_$][a-zA-Z0-9_$]*)|\*\*|\*|\(|\)|\\\(|\\\)/g;var escapeRegExp=function(string){return string.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")};function _compilePattern(pattern){var regexpSource="";var paramNames=[];var tokens=[];var match;var lastIndex=0;while(match=matcher.exec(pattern)){if(match.index!==lastIndex){tokens.push(pattern.slice(lastIndex,match.index));regexpSource+=escapeRegExp(pattern.slice(lastIndex,match.index))}if(match[1]){regexpSource+="([^/]+)";paramNames.push(match[1])}else if(match[0]==="**"){regexpSource+="(.*)";paramNames.push("splat")}else if(match[0]==="*"){regexpSource+="(.*?)";paramNames.push("splat")}else if(match[0]==="("){regexpSource+="(?:"}else if(match[0]===")"){regexpSource+=")?"}else if(match[0]==="\\("){regexpSource+="\\("}else if(match[0]==="\\)"){regexpSource+="\\)"}tokens.push(match[0]);lastIndex=matcher.lastIndex}if(lastIndex!==pattern.length){tokens.push(pattern.slice(lastIndex,pattern.length));regexpSource+=escapeRegExp(pattern.slice(lastIndex,pattern.length))}return{pattern:pattern,regexpSource:regexpSource,paramNames:paramNames,tokens:tokens}}var CompiledPatternsCache=Object.create(null);export function compilePattern(pattern){if(!CompiledPatternsCache[pattern])CompiledPatternsCache[pattern]=_compilePattern(pattern);return CompiledPatternsCache[pattern]}export function matchPattern(pattern,pathname){if(pattern.charAt(0)!=="/"){pattern="/"+pattern}var ref=compilePattern(pattern),regexpSource=ref.regexpSource,paramNames=ref.paramNames,tokens=ref.tokens;if(pattern.charAt(pattern.length-1)!=="/"){regexpSource+="/?"}if(tokens[tokens.length-1]==="*"){regexpSource+="$"}var match=pathname.match(new RegExp("^"+regexpSource,"i"));if(match==null){return null}var matchedPath=match[0];var remainingPathname=pathname.substring(matchedPath.length);if(remainingPathname){if(matchedPath.charAt(matchedPath.length-1)!=="/"){return null}remainingPathname="/"+remainingPathname}return{remainingPathname:remainingPathname,paramNames:paramNames,paramValues:match.slice(1).map(function(v){return v&&decodeURIComponent(v)})}}export function getParamNames(pattern){return compilePattern(pattern).paramNames}export function getParams(pattern,pathname){var match=matchPattern(pattern,pathname);if(!match){return null}var paramNames=match.paramNames,paramValues=match.paramValues;var params={};paramNames.forEach(function(paramName,index){params[paramName]=paramValues[index]});return params}export function formatPattern(pattern,params){if(params===void 0)params={};var tokens=compilePattern(pattern).tokens;var parenCount=0;var pathname="";var splatIndex=0;var parenHistory=[];var token,paramName,paramValue;for(var i=0,len=tokens.length;i<len;++i){token=tokens[i];if(token==="*"||token==="**"){paramValue=Array.isArray(params.splat)?params.splat[splatIndex++]:params.splat;invariant(paramValue!=null||parenCount>0,"Missing splat #"+splatIndex+' for path "'+pattern+'"');if(paramValue!=null)pathname+=encodeURI(paramValue)}else if(token==="("){parenHistory[parenCount]="";parenCount+=1}else if(token===")"){var parenText=parenHistory.pop();parenCount-=1;if(parenCount)parenHistory[parenCount-1]+=parenText;else pathname+=parenText}else if(token==="\\("){pathname+="("}else if(token==="\\)"){pathname+=")"}else if(token.charAt(0)===":"){paramName=token.substring(1);paramValue=params[paramName];invariant(paramValue!=null||parenCount>0,'Missing "'+paramName+'" parameter for path "'+pattern+'"');if(paramValue==null){if(parenCount){parenHistory[parenCount-1]="";var curTokenIdx=tokens.indexOf(token);var tokensSubset=tokens.slice(curTokenIdx,tokens.length);var nextParenIdx=-1;for(var i1=0;i1<tokensSubset.length;i1++){if(tokensSubset[i1]===")"){nextParenIdx=i1;break}}invariant(nextParenIdx>0,'Path "'+pattern+'" is missing end paren at segment "'+tokensSubset.join("")+'"');i=curTokenIdx+nextParenIdx-1}}else if(parenCount)parenHistory[parenCount-1]+=encodeURIComponent(paramValue);else pathname+=encodeURIComponent(paramValue)}else{if(parenCount)parenHistory[parenCount-1]+=token;else pathname+=token}}invariant(parenCount<=0,'Path "'+pattern+'" is missing end paren');return pathname.replace(/\/+/g,"/")}